package io.zipcoder.crudapp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;


@RestController
public class PersonController {

    @Autowired
    PersonRepository personRepository;

    @PostMapping("/people")
    public ResponseEntity<Person> createPerson(@RequestBody Person person){
        return new ResponseEntity<>(personRepository.save(person), HttpStatus.CREATED);

    }

    @GetMapping("/people/{id}")
    public ResponseEntity<Person> getPerson(@PathVariable Long id){
        return new ResponseEntity<>(personRepository.findOne(id), HttpStatus.OK);

    }

    @GetMapping("/people")
    public ResponseEntity<Iterable<Person>> getPersonList(){
        return new ResponseEntity<>(personRepository.findAll(), HttpStatus.OK);

    }

    @PutMapping("/people")
    public void updatePerson(@RequestBody Person person){
        Long id = person.getId();
        Person personUpdate = personRepository.findOne(id);

        personUpdate.setLastname(person.getLastname());
        personUpdate.setFirstname(person.getFirstname());

        personRepository.save(personUpdate);
    }

    @DeleteMapping("/people/{id}")
    public void deletePerson(@PathVariable Long id){
        personRepository.delete(id);

    }
}
